<?xml version="1.0" encoding="utf-8"?>

<!--      
    Author:			Johannes Schuh
     
	Description:	Stylesheet for Microsoft Word 2007/2008/2010/2013/2016 Bibliography
					formatting.
					Implemented are
						- Books,
						- InternetSites,
						- DocumentFromInternetSite,
						- JournalArticle,
						- Case,
						- Misc.
					You can find an installation guide for Windows and Mac
					on http://www.pineappledeveloper.com/
	 
    Copyright:		Copyright (c) 2016, Pineapple Developer, Inhaber Johannes Schuh
					All rights reserved.
					Framework by: bibword.codeplex.com
					
					You are allowed to use this software to style your bibliography
					in Microsoft Word. You are not allowed to modify or publish it.

					There is no warranty that the citations are correct. This template
					does only support you to create a scientific work. The author of
					the document will always be responsible for citations.
-->

<xsl:stylesheet version="1.0" xmlns:b="http://schemas.openxmlformats.org/officeDocument/2006/bibliography" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:msxsl="urn:schemas-microsoft-com:xslt"><xsl:variable name="data"><general><stylename>Pineapple Developer</stylename><version>2016</version><version2013>2016</version2013><author>Johannes Schuh</author><description>Bibliography style designed by Pineapple Developer, Inhaber Johannes Schuh</description><URL>http://www.pineappledeveloper.com/</URL><comments /><display_errors>no</display_errors><citation_as_link>no</citation_as_link></general><importantfields><source type="Book"><b:ImportantField>b:Author/b:Author/b:NameList</b:ImportantField><b:ImportantField>b:Author/b:Editor/b:NameList</b:ImportantField><b:ImportantField>b:Title</b:ImportantField><b:ImportantField>b:Edition</b:ImportantField><b:ImportantField>b:Year</b:ImportantField><b:ImportantField>b:City</b:ImportantField><b:ImportantField>b:Publisher</b:ImportantField><b:ImportantField>b:StandardNumber</b:ImportantField></source><source type="InternetSite"><b:ImportantField>b:Author/b:Author/b:NameList</b:ImportantField><b:ImportantField>b:Author/b:Editor/b:NameList</b:ImportantField><b:ImportantField>b:InternetSiteTitle</b:ImportantField><b:ImportantField>b:URL</b:ImportantField><b:ImportantField>b:Year</b:ImportantField><b:ImportantField>b:YearAccessed</b:ImportantField><b:ImportantField>b:MonthAccessed</b:ImportantField><b:ImportantField>b:DayAccessed</b:ImportantField></source><source type="DocumentFromInternetSite"><b:ImportantField>b:Author/b:Author/b:NameList</b:ImportantField><b:ImportantField>b:Author/b:Editor/b:NameList</b:ImportantField><b:ImportantField>b:InternetSiteTitle</b:ImportantField><b:ImportantField>b:URL</b:ImportantField><b:ImportantField>b:Year</b:ImportantField><b:ImportantField>b:YearAccessed</b:ImportantField><b:ImportantField>b:MonthAccessed</b:ImportantField><b:ImportantField>b:DayAccessed</b:ImportantField></source><source type="JournalArticle"><b:ImportantField>b:Author/b:Author/b:NameList</b:ImportantField><b:ImportantField>b:Author/b:Editor/b:NameList</b:ImportantField><b:ImportantField>b:Title</b:ImportantField><b:ImportantField>b:JournalName</b:ImportantField><b:ImportantField>b:Volume</b:ImportantField><b:ImportantField>b:Issue</b:ImportantField><b:ImportantField>b:Year</b:ImportantField><b:ImportantField>b:Pages</b:ImportantField></source><source type="Case"><b:ImportantField>b:Title</b:ImportantField><b:ImportantField>b:CaseNumber</b:ImportantField><b:ImportantField>b:Court</b:ImportantField><b:ImportantField>b:Year</b:ImportantField><b:ImportantField>b:Month</b:ImportantField><b:ImportantField>b:Day</b:ImportantField></source><source type="Misc"><b:ImportantField>b:Volume</b:ImportantField><b:ImportantField>b:Title</b:ImportantField><b:ImportantField>b:Issue</b:ImportantField></source></importantfields><citation><openbracket /><closebracket /><separator>,</separator><noauthor></noauthor><notitle></notitle><noyear></noyear><source type="Book"><format>{%CitationPrefix%}{%Author:1|Editor:3%}{, %Year%}{, %CitationPages:S. :S. %}{%CitationSuffix%}.</format></source><source type="InternetSite"><format>{%CitationPrefix%}{%Author:1|Editor:3%}{, %Year%}{, "%InternetSiteTitle%"}{%CitationSuffix%}.</format></source><source type="DocumentFromInternetSite"><format>{%CitationPrefix%}{%Author:1|Editor:3%}{, %Year%}{, "%InternetSiteTitle%"}{, %CitationPages:S. :S. %}{%CitationSuffix%}.</format></source><source type="JournalArticle"><format>{%CitationPrefix%}{%Author:1|Editor:3%}{, %Year%}{, %CitationPages:S. :S. %}{%CitationSuffix%}.</format></source><source type="Case"><format>{%CitationPrefix%}{%Court%}{, Urteil v. {%Day%.%Month%.%Year%}}{ (Az. %CaseNumber%)}{%CitationSuffix%}.</format></source><source type="Misc"><format>{%CitationPrefix%}{§ %Title%}{ Abs. %Issue%}{ %Volume%}{%CitationSuffix%}.</format></source></citation><bibliography><columns>1</columns><source type="Book"><column id="1"><halign>left</halign><valign>top</valign><format>{%Author:2|Editor:4 (Hrsg.)%}{ (%Year%)}:{ %Title%}{, %Edition%. Aufl.}{, %City%: %Publisher%}{, %Year%}.</format></column><sortkey>%Author:2%</sortkey></source><source type="InternetSite"><column id="1"><halign>left</halign><valign>top</valign><format>{%Author:2|Editor:4 (Hrsg.)%}{ (%Year%)}:{ %InternetSiteTitle%}{, %Year%}{, %URL:l%}{ (Zugriff am %DayAccessed%. %MonthAccessed:s% %YearAccessed%)}.</format></column><sortkey>%Author:2%</sortkey></source><source type="DocumentFromInternetSite"><column id="1"><halign>left</halign><valign>top</valign><format>{%Author:2|Editor:4 (Hrsg.)%}{ (%Year%)}:{ %InternetSiteTitle%}{, %Year%}{, %URL:l%}{ (Zugriff am %DayAccessed%. %MonthAccessed:s% %YearAccessed%)}.</format></column><sortkey>%Author:2%</sortkey></source><source type="JournalArticle"><column id="1"><halign>left</halign><valign>top</valign><format>{%Author:2|Editor:4 (Hrsg.)%}{ (%Year%)}:{ %Title%}{, in: %JournalName%}{, Band %Volume%}{, Heft %Issue%}{, %Year%}{, %Pages: S. :S. %}.</format></column><sortkey>%Author:2%</sortkey></source><source type="Misc"><column id="1"><halign>left</halign><valign>top</valign><format></format></column><sortkey></sortkey></source></bibliography><namelists><list name="author" id="1"><single_prefix /><multi_prefix /><corporate>{%Corporate%}</corporate><first_person>{%Last%}</first_person><other_persons> et al.</other_persons><separator_between_if_two></separator_between_if_two><separator_between_if_more_than_two></separator_between_if_more_than_two><separator_before_last></separator_before_last><max_number_of_persons_to_display>2</max_number_of_persons_to_display><number_of_persons_to_display_if_more_than_max>2</number_of_persons_to_display_if_more_than_max><overflow></overflow><single_suffix /><multi_suffix /></list><list name="author" id="2"><single_prefix /><multi_prefix /><corporate>{%Corporate%}</corporate><first_person>{%Last%}{ %First%}</first_person><other_persons>{%Last%}{ %First%}</other_persons><separator_between_if_two> und </separator_between_if_two><separator_between_if_more_than_two>, </separator_between_if_more_than_two><separator_before_last> und </separator_before_last><max_number_of_persons_to_display>5</max_number_of_persons_to_display><number_of_persons_to_display_if_more_than_max>1</number_of_persons_to_display_if_more_than_max><overflow></overflow><single_suffix /><multi_suffix /></list><list name="editor" id="3"><single_prefix /><multi_prefix /><corporate>{%Corporate%}</corporate><first_person>{%Last%}</first_person><other_persons>{%Last%}</other_persons><separator_between_if_two> und </separator_between_if_two><separator_between_if_more_than_two>, </separator_between_if_more_than_two><separator_before_last></separator_before_last><max_number_of_persons_to_display>2</max_number_of_persons_to_display><number_of_persons_to_display_if_more_than_max>2</number_of_persons_to_display_if_more_than_max><overflow></overflow><single_suffix /><multi_suffix /></list><list name="editor" id="4"><single_prefix /><multi_prefix /><corporate>{%Corporate%}</corporate><first_person>{%Last%}{ %First%}</first_person><other_persons>{%Last%}{ %First%}</other_persons><separator_between_if_two> und </separator_between_if_two><separator_between_if_more_than_two>, </separator_between_if_more_than_two><separator_before_last> und </separator_before_last><max_number_of_persons_to_display>5</max_number_of_persons_to_display><number_of_persons_to_display_if_more_than_max>1</number_of_persons_to_display_if_more_than_max><overflow></overflow><single_suffix /><multi_suffix /></list></namelists><strings><months><month number="1">Januar</month><month number="2">Februar</month><month number="3">März</month><month number="4">April</month><month number="5">Mai</month><month number="6">Juni</month><month number="7">Juli</month><month number="8">August</month><month number="9">September</month><month number="10">Oktober</month><month number="11">November</month><month number="12">Dezember</month></months></strings></xsl:variable><xsl:output method="html" encoding="utf-8"/><xsl:template match="/"><xsl:choose><xsl:when test="b:StyleName"><xsl:value-of select="msxsl:node-set($data)/general/stylename"/></xsl:when><xsl:when test="b:Version"><xsl:value-of select="msxsl:node-set($data)/general/version"/></xsl:when><xsl:when test="b:XslVersion"><xsl:choose><xsl:when test="msxsl:node-set($data)/general/version2013"><xsl:value-of select="msxsl:node-set($data)/general/version2013"/></xsl:when><xsl:otherwise><xsl:text>1</xsl:text></xsl:otherwise></xsl:choose></xsl:when><xsl:when test="b:StyleNameLocalized"><xsl:value-of select="msxsl:node-set($data)/general/stylename"/></xsl:when><xsl:when test="b:Description"><xsl:value-of select="msxsl:node-set($data)/general/description"/></xsl:when><xsl:when test="b:UpdateURL"><xsl:value-of select="msxsl:node-set($data)/general/URL"/></xsl:when><xsl:when test="b:GetImportantFields"><xsl:variable name="type" select="b:GetImportantFields/b:SourceType"/><b:ImportantFields><xsl:copy-of select="msxsl:node-set($data)/importantfields/source[@type = $type]/*"/></b:ImportantFields></xsl:when><xsl:when test="b:Citation"><xsl:choose><xsl:when test="msxsl:node-set($data)/citation"><xsl:call-template name="format-citation"/></xsl:when><xsl:otherwise><xsl:call-template name="format-footnote-citation"/></xsl:otherwise></xsl:choose></xsl:when><xsl:when test="b:FootnoteCitation"><xsl:choose><xsl:when test="msxsl:node-set($data)/footnotecitation"><xsl:call-template name="format-footnote-citation"/></xsl:when><xsl:otherwise><xsl:call-template name="format-citation"/></xsl:otherwise></xsl:choose></xsl:when><xsl:when test="b:Bibliography"><xsl:call-template name="format-bibliography"/></xsl:when><xsl:when test="b:BibWord"><xsl:call-template name="bibword-extensions"/></xsl:when></xsl:choose></xsl:template><xsl:template name="format-citation"><xsl:variable name="params" select="msxsl:node-set($data)"/><html xmlns="http://www.w3.org/TR/REC-html40"><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8"/></head><body><p><xsl:if test="/b:Citation/b:FirstAuthor"><xsl:value-of select="$params/citation/openbracket" disable-output-escaping="yes"/></xsl:if><xsl:variable name="citation"><xsl:variable name="format"><xsl:variable name="type" select="/b:Citation/b:Source/b:Type"/><xsl:variable name="sourcetype" select="/b:Citation/b:Source/b:SourceType"/><xsl:choose><xsl:when test="string-length($sourcetype) = 0 and string-length(msxsl:node-set($data)/citation/source[@type = 'Placeholder']/format) > 0"><xsl:value-of select="msxsl:node-set($data)/citation/source[@type = 'Placeholder']/format"/></xsl:when><xsl:when test="string-length($type) > 0 and string-length(msxsl:node-set($data)/citation/source[@type = $type]/format) > 0 "><xsl:value-of select="msxsl:node-set($data)/citation/source[@type = $type]/format"/></xsl:when><xsl:when test="string-length(msxsl:node-set($data)/citation/source[@type = $sourcetype]/format) > 0 "><xsl:value-of select="msxsl:node-set($data)/citation/source[@type = $sourcetype]/format"/></xsl:when><xsl:otherwise><xsl:if test="msxsl:node-set($data)/general/display_errors = 'yes'"><xsl:text>&lt;b&gt;Unsupported </xsl:text><xsl:if test="string-length($type) > 0"><xsl:text>type (</xsl:text><xsl:value-of select="$type"/><xsl:text>) and </xsl:text></xsl:if><xsl:text>source type (</xsl:text><xsl:value-of select="$sourcetype"/><xsl:text>) for source </xsl:text><xsl:value-of select="/b:Citation/b:Source/b:Tag"/><xsl:text>.&lt;/b&gt;</xsl:text></xsl:if></xsl:otherwise></xsl:choose></xsl:variable><xsl:variable name="extendedSource"><b:Source><xsl:copy-of select="/b:Citation/b:Source/*"/><b:CitationPrefix><xsl:value-of select="/b:Citation/b:PagePrefix"/></b:CitationPrefix><b:CitationSuffix><xsl:value-of select="/b:Citation/b:PageSuffix"/></b:CitationSuffix><b:CitationPages><xsl:value-of select="/b:Citation/b:Pages"/></b:CitationPages><b:CitationVolume><xsl:value-of select="/b:Citation/b:Volume"/></b:CitationVolume></b:Source></xsl:variable><xsl:call-template name="format-source"><xsl:with-param name="format" select="$format"/><xsl:with-param name="source" select="msxsl:node-set($extendedSource)/b:Source"/><xsl:with-param name="disallowed"><xsl:if test="/b:Citation/b:NoAuthor"><xsl:value-of select="msxsl:node-set($data)/citation/noauthor"/></xsl:if><xsl:if test="/b:Citation/b:NoTitle"><xsl:value-of select="msxsl:node-set($data)/citation/notitle"/></xsl:if><xsl:if test="/b:Citation/b:NoYear"><xsl:value-of select="msxsl:node-set($data)/citation/noyear"/></xsl:if></xsl:with-param></xsl:call-template></xsl:variable><xsl:choose><xsl:when test="$params/general/citation_as_link = 'yes'"><a href="#{/b:Citation/b:Source/b:Tag}"><xsl:value-of select="$citation" disable-output-escaping="yes"/></a></xsl:when><xsl:otherwise><xsl:value-of select="$citation" disable-output-escaping="yes"/></xsl:otherwise></xsl:choose><xsl:if test="not(/b:Citation/b:LastAuthor)"><xsl:value-of select="$params/citation/separator" disable-output-escaping="yes"/></xsl:if><xsl:if test="/b:Citation/b:LastAuthor"><xsl:value-of select="$params/citation/closebracket" disable-output-escaping="yes"/></xsl:if></p></body></html></xsl:template><xsl:template name="format-footnote-citation"><xsl:variable name="params" select="msxsl:node-set($data)"/><html xmlns="http://www.w3.org/TR/REC-html40"><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8"/></head><body><p class="MsoBibliography"><xsl:if test="/b:FootnoteCitation/b:FirstAuthor"><xsl:value-of select="$params/footnotecitation/openbracket" disable-output-escaping="yes"/></xsl:if><xsl:variable name="citation"><xsl:variable name="format"><xsl:variable name="type" select="/b:FootnoteCitation/b:Source/b:Type"/><xsl:variable name="sourcetype" select="/b:FootnoteCitation/b:Source/b:SourceType"/><xsl:choose><xsl:when test="string-length($sourcetype) = 0 and string-length(msxsl:node-set($data)/footnotecitation/source[@type = 'Placeholder']/format) > 0"><xsl:value-of select="msxsl:node-set($data)/footnotecitation/source[@type = 'Placeholder']/format"/></xsl:when><xsl:when test="string-length($type) > 0 and string-length(msxsl:node-set($data)/footnotecitation/source[@type = $type]/format) > 0 "><xsl:value-of select="msxsl:node-set($data)/footnotecitation/source[@type = $type]/format"/></xsl:when><xsl:when test="string-length(msxsl:node-set($data)/footnotecitation/source[@type = $sourcetype]/format) > 0 "><xsl:value-of select="msxsl:node-set($data)/footnotecitation/source[@type = $sourcetype]/format"/></xsl:when><xsl:otherwise><xsl:if test="msxsl:node-set($data)/general/display_errors = 'yes'"><xsl:text>&lt;b&gt;Unsupported </xsl:text><xsl:if test="string-length($type) > 0"><xsl:text>type (</xsl:text><xsl:value-of select="$type"/><xsl:text>) and </xsl:text></xsl:if><xsl:text>source type (</xsl:text><xsl:value-of select="$sourcetype"/><xsl:text>) for source </xsl:text><xsl:value-of select="/b:FootnoteCitation/b:Source/b:Tag"/><xsl:text>.&lt;/b&gt;</xsl:text></xsl:if></xsl:otherwise></xsl:choose></xsl:variable><xsl:variable name="extendedSource"><b:Source><xsl:copy-of select="/b:FootnoteCitation/b:Source/*"/><b:FootnoteCitationPrefix><xsl:value-of select="/b:FootnoteCitation/b:PagePrefix"/></b:FootnoteCitationPrefix><b:FootnoteCitationSuffix><xsl:value-of select="/b:FootnoteCitation/b:PageSuffix"/></b:FootnoteCitationSuffix><b:FootnoteCitationPages><xsl:value-of select="/b:FootnoteCitation/b:Pages"/></b:FootnoteCitationPages><b:FootnoteCitationVolume><xsl:value-of select="/b:FootnoteCitation/b:Volume"/></b:FootnoteCitationVolume></b:Source></xsl:variable><xsl:call-template name="format-source"><xsl:with-param name="format" select="$format"/><xsl:with-param name="source" select="msxsl:node-set($extendedSource)/b:Source"/><xsl:with-param name="disallowed"><xsl:if test="/b:FootnoteCitation/b:NoAuthor"><xsl:value-of select="msxsl:node-set($data)/citation/noauthor"/></xsl:if><xsl:if test="/b:FootnoteCitation/b:NoTitle"><xsl:value-of select="msxsl:node-set($data)/citation/notitle"/></xsl:if><xsl:if test="/b:FootnoteCitation/b:NoYear"><xsl:value-of select="msxsl:node-set($data)/citation/noyear"/></xsl:if></xsl:with-param></xsl:call-template></xsl:variable><xsl:value-of select="$citation" disable-output-escaping="yes"/><xsl:if test="not(/b:FootnoteCitation/b:LastAuthor)"><xsl:value-of select="$params/citation/separator" disable-output-escaping="yes"/></xsl:if><xsl:if test="/b:FootnoteCitation/b:LastAuthor"><xsl:value-of select="$params/citation/closebracket" disable-output-escaping="yes"/></xsl:if></p></body></html></xsl:template><xsl:template name="format-bibliography"><xsl:variable name="extendedBib"><b:Bibliography><xsl:for-each select="/b:Bibliography/b:Source"><b:Source><xsl:copy-of select="./*"/><xsl:call-template name="create-sortkey"><xsl:with-param name="source" select="."/></xsl:call-template></b:Source></xsl:for-each></b:Bibliography></xsl:variable><html xmlns="http://www.w3.org/TR/REC-html40"><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8"/><style>
          p.MsoBibliography
        </style></head><body><xsl:choose><xsl:when test="msxsl:node-set($data)/bibliography/columns > 1"><xsl:call-template name="format-bibliography-as-table"><xsl:with-param name="bibNodeSet" select="msxsl:node-set($extendedBib)"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:call-template name="format-bibliography-as-paragraphs"><xsl:with-param name="bibNodeSet" select="msxsl:node-set($extendedBib)"/></xsl:call-template></xsl:otherwise></xsl:choose></body></html></xsl:template><xsl:template name="format-bibliography-as-paragraphs"><xsl:param name="bibNodeSet"/><xsl:for-each select="$bibNodeSet/b:Bibliography/b:Source"><xsl:sort select="b:SortKey" data-type="text"/><p class="MsoBibliography"><xsl:variable name="format"><xsl:variable name="type" select="./b:Type"/><xsl:variable name="sourcetype" select="./b:SourceType"/><xsl:choose><xsl:when test="string-length($sourcetype) = 0 and string-length(msxsl:node-set($data)/bibliography/source[@type = 'Placeholder']/column[@id = '1']/format) > 0"><xsl:value-of select="msxsl:node-set($data)/bibliography/source[@type = 'Placeholder']/column[@id = '1']/format"/></xsl:when><xsl:when test="string-length($type) > 0 and string-length(msxsl:node-set($data)/bibliography/source[@type = $type]/column[@id = '1']/format) > 0 "><xsl:value-of select="msxsl:node-set($data)/bibliography/source[@type = $type]/column[@id = '1']/format"/></xsl:when><xsl:when test="string-length(msxsl:node-set($data)/bibliography/source[@type = $sourcetype]/column[@id = '1']/format) > 0 "><xsl:value-of select="msxsl:node-set($data)/bibliography/source[@type = $sourcetype]/column[@id = '1']/format"/></xsl:when><xsl:otherwise><xsl:if test="msxsl:node-set($data)/general/display_errors = 'yes'"><xsl:text>&lt;b&gt;Unsupported </xsl:text><xsl:if test="string-length($type) > 0"><xsl:text>type (</xsl:text><xsl:value-of select="$type"/><xsl:text>) and </xsl:text></xsl:if><xsl:text>source type (</xsl:text><xsl:value-of select="$sourcetype"/><xsl:text>) for source </xsl:text><xsl:value-of select="./b:Tag"/><xsl:text>.&lt;/b&gt;</xsl:text></xsl:if></xsl:otherwise></xsl:choose></xsl:variable><xsl:variable name="paragraphX"><xsl:call-template name="format-source"><xsl:with-param name="format" select="$format"/><xsl:with-param name="source" select="."/></xsl:call-template></xsl:variable><xsl:choose><xsl:when test="msxsl:node-set($data)/general/citation_as_link = 'yes'"><a name="{./b:Tag}"><xsl:value-of select="$paragraphX" disable-output-escaping="yes"/></a></xsl:when><xsl:otherwise><xsl:value-of select="$paragraphX" disable-output-escaping="yes"/></xsl:otherwise></xsl:choose></p></xsl:for-each></xsl:template><xsl:template name="format-bibliography-as-table"><xsl:param name="bibNodeSet"/><p class="MsoBibliography" style="display:none;">x</p><table width="100%"><xsl:for-each select="$bibNodeSet/b:Bibliography/b:Source"><xsl:sort select="b:SortKey" data-type="text"/><tr><xsl:call-template name="format-bibliography-table-column"><xsl:with-param name="columnId" select="1"/><xsl:with-param name="source" select="."/></xsl:call-template></tr></xsl:for-each></table><p class="MsoBibliography" style="display:none;">x</p></xsl:template><xsl:template name="format-bibliography-table-column"><xsl:param name="source"/><xsl:param name="columnId"/><xsl:variable name="params" select="msxsl:node-set($data)"/><xsl:variable name="format"><xsl:variable name="type" select="./b:Type"/><xsl:variable name="sourcetype" select="./b:SourceType"/><xsl:choose><xsl:when test="string-length($sourcetype) = 0 and string-length(msxsl:node-set($data)/bibliography/source[@type = 'Placeholder']/column[@id = $columnId]/format) > 0"><xsl:value-of select="msxsl:node-set($data)/bibliography/source[@type = 'Placeholder']/column[@id = $columnId]/format"/></xsl:when><xsl:when test="string-length($type) > 0 and string-length(msxsl:node-set($data)/bibliography/source[@type = $type]/column[@id = $columnId]/format) > 0 "><xsl:value-of select="msxsl:node-set($data)/bibliography/source[@type = $type]/column[@id = $columnId]/format"/></xsl:when><xsl:when test="string-length(msxsl:node-set($data)/bibliography/source[@type = $sourcetype]/column[@id = $columnId]/format) > 0 "><xsl:value-of select="msxsl:node-set($data)/bibliography/source[@type = $sourcetype]/column[@id = $columnId]/format"/></xsl:when><xsl:otherwise><xsl:if test="msxsl:node-set($data)/general/display_errors = 'yes'"><xsl:text>&lt;b&gt;Unsupported </xsl:text><xsl:if test="string-length($type) > 0"><xsl:text>type (</xsl:text><xsl:value-of select="$type"/><xsl:text>) and </xsl:text></xsl:if><xsl:text>source type (</xsl:text><xsl:value-of select="$sourcetype"/><xsl:text>) for source </xsl:text><xsl:value-of select="./b:Tag"/><xsl:text>.&lt;/b&gt;</xsl:text></xsl:if></xsl:otherwise></xsl:choose></xsl:variable><xsl:variable name="type"><xsl:variable name="temp" select="$source/b:Type"/><xsl:variable name="temp2" select="$source/b:SourceType"/><xsl:choose><xsl:when test="string-length($temp2) = 0 and string-length(msxsl:node-set($data)/bibliography/source[@type = $temp2]/column[@id = $columnId]/format) > 0 "><xsl:value-of select="'Placeholder'"/></xsl:when><xsl:when test="string-length($temp) > 0 and string-length(msxsl:node-set($data)/bibliography/source[@type = $temp]/column[@id = $columnId]/format) > 0 "><xsl:value-of select="$temp"/></xsl:when><xsl:otherwise><xsl:value-of select="$source/b:SourceType"/></xsl:otherwise></xsl:choose></xsl:variable><td align="{$params/bibliography/source[@type = $type]/column[@id = $columnId]/halign}" valign="{$params/bibliography/source[@type = $type]/column[@id = $columnId]/valign}"><p class="MsoBibliography"><xsl:variable name="columnX"><xsl:call-template name="format-source"><xsl:with-param name="format" select="$format"/><xsl:with-param name="source" select="$source"/></xsl:call-template></xsl:variable><xsl:choose><xsl:when test="msxsl:node-set($data)/general/citation_as_link = 'yes' and $columnId = 1"><a name="{$source/b:Tag}"><xsl:value-of select="$columnX" disable-output-escaping="yes"/></a></xsl:when><xsl:otherwise><xsl:value-of select="$columnX" disable-output-escaping="yes"/></xsl:otherwise></xsl:choose></p></td><xsl:if test="$params/bibliography/columns > $columnId"><xsl:call-template name="format-bibliography-table-column"><xsl:with-param name="source" select="$source"/><xsl:with-param name="columnId" select="$columnId + 1"/></xsl:call-template></xsl:if></xsl:template><xsl:template name="preprocess-format-string"><xsl:param name="string"/><xsl:text>{0}</xsl:text><xsl:call-template name="preprocess-format-string-part-2"><xsl:with-param name="string" select="$string"/></xsl:call-template><xsl:text>{0}</xsl:text></xsl:template><xsl:template name="preprocess-format-string-part-2"><xsl:param name="string"/><xsl:param name="level" select="0"/><xsl:if test="string-length($string) > 0"><xsl:variable name="firstChar" select="substring($string, 1, 1)"/><xsl:choose><xsl:when test="$firstChar = '{'"><xsl:variable name="nextLevel" select="$level + 1"/><xsl:text>{</xsl:text><xsl:value-of select="$nextLevel"/><xsl:text>}</xsl:text><xsl:call-template name="preprocess-format-string-part-2"><xsl:with-param name="string" select="substring($string, 2)"/><xsl:with-param name="level" select="$nextLevel"/></xsl:call-template></xsl:when><xsl:when test="$firstChar = '}'"><xsl:text>{</xsl:text><xsl:value-of select="$level"/><xsl:text>}</xsl:text><xsl:call-template name="preprocess-format-string-part-2"><xsl:with-param name="string" select="substring($string, 2)"/><xsl:with-param name="level" select="$level - 1"/></xsl:call-template></xsl:when><xsl:when test="$firstChar = '%'"><xsl:text>%</xsl:text><xsl:value-of select="$level"/><xsl:text>%</xsl:text><xsl:value-of select="substring-before(substring($string, 2), '%')"/><xsl:text>%</xsl:text><xsl:value-of select="$level"/><xsl:text>%</xsl:text><xsl:call-template name="preprocess-format-string-part-2"><xsl:with-param name="string" select="substring-after(substring($string, 2), '%')"/><xsl:with-param name="level" select="$level"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$firstChar"/><xsl:call-template name="preprocess-format-string-part-2"><xsl:with-param name="string" select="substring($string, 2)"/><xsl:with-param name="level" select="$level"/></xsl:call-template></xsl:otherwise></xsl:choose></xsl:if></xsl:template><xsl:template name="format-source"><xsl:param name="source"/><xsl:param name="format"/><xsl:param name="disallowed"/><xsl:call-template name="clean-punctuation"><xsl:with-param name="string"><xsl:call-template name="format-source-part-2"><xsl:with-param name="source" select="$source"/><xsl:with-param name="format"><xsl:call-template name="preprocess-format-string"><xsl:with-param name="string" select="$format"/></xsl:call-template></xsl:with-param><xsl:with-param name="used" select="$disallowed"/></xsl:call-template></xsl:with-param></xsl:call-template></xsl:template><xsl:template name="format-source-part-2"><xsl:param name="source"/><xsl:param name="format"/><xsl:param name="used"/><xsl:choose><xsl:when test="contains($format, '{')"><xsl:variable name="level" select="substring-before(substring-after($format, '{'), '}')"/><xsl:variable name="delim" select="concat('{', $level,'}')"/><xsl:variable name="current"><xsl:call-template name="format-source-part-3"><xsl:with-param name="source" select="$source"/><xsl:with-param name="format" select="substring-before(substring-after($format, $delim), $delim)"/><xsl:with-param name="used" select="$used"/><xsl:with-param name="level" select="$level"/></xsl:call-template></xsl:variable><xsl:value-of select="substring-before($format, $delim)"/><xsl:call-template name="format-source-part-2"><xsl:with-param name="source" select="$source"/><xsl:with-param name="format"><xsl:value-of select="msxsl:node-set($current)/output"/><xsl:value-of select="substring-after(substring-after($format, $delim), $delim)"/></xsl:with-param><xsl:with-param name="used" select="concat($used, msxsl:node-set($current)/used)"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$format"/></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="format-source-part-3"><xsl:param name="source"/><xsl:param name="format"/><xsl:param name="used"/><xsl:param name="level"/><xsl:param name="outputAtCurrentLevel" select="''"/><xsl:param name="usedAtCurrentLevel" select="''"/><xsl:choose><xsl:when test="string-length($format) > 0"><xsl:variable name="delim" select="concat('%', $level, '%')"/><xsl:choose><xsl:when test="contains($format, $delim)"><xsl:variable name="name"><xsl:call-template name="get-source-parameter"><xsl:with-param name="parameters" select="substring-before(substring-after($format, $delim), $delim)"/><xsl:with-param name="source" select="$source"/><xsl:with-param name="used" select="concat($used, $usedAtCurrentLevel)"/></xsl:call-template></xsl:variable><xsl:variable name="result"><xsl:if test="string-length($name) > 0"><xsl:variable name="options"><xsl:call-template name="substring-before-ex"><xsl:with-param name="string" select="substring-after(substring-before(substring-after($format, $delim), $delim), concat($name, ':'))"/><xsl:with-param name="delimeter" select="'|'"/></xsl:call-template></xsl:variable><xsl:choose><xsl:when test="starts-with($name, '&#x22;') and substring($name, string-length($name), 1) = '&#x22;'"><xsl:value-of select="substring-before(substring-after($name, '&#x22;'), '&#x22;')"/></xsl:when><xsl:when test="string($source/b:Author/*[local-name() = $name])"><xsl:variable name="options2" select="translate($options, translate($options, '0123456789', ''), '')"/><xsl:choose><xsl:when test="string-length($options2) > 0"><xsl:call-template name="format-contributors-by-params"><xsl:with-param name="contributors" select="$source/b:Author/*[local-name() = $name]"/><xsl:with-param name="params" select="msxsl:node-set($data)/namelists/list[@id = $options2]"/></xsl:call-template></xsl:when><xsl:when test="translate($options, translate($options, 'c', ''), '') = 'c'"><xsl:call-template name="count-contributors"><xsl:with-param name="contributors" select="$source/b:Author/*[local-name() = $name]"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:call-template name="format-contributors-by-params"><xsl:with-param name="contributors" select="$source/b:Author/*[local-name() = $name]"/><xsl:with-param name="params" select="msxsl:node-set($data)/namelists/list[@id = 0]"/></xsl:call-template></xsl:otherwise></xsl:choose></xsl:when><xsl:when test="$name = 'Pages' and string($source/b:Pages)"><xsl:call-template name="format-pages"><xsl:with-param name="pages" select="$source/b:Pages"/><xsl:with-param name="options" select="$options"/></xsl:call-template></xsl:when><xsl:when test="$name = 'CitationPages' and string($source/b:CitationPages)"><xsl:call-template name="format-pages"><xsl:with-param name="pages" select="$source/b:CitationPages"/><xsl:with-param name="options" select="$options"/></xsl:call-template></xsl:when><xsl:when test="$name = 'URL' and string($source/b:URL)"><xsl:call-template name="format-url"><xsl:with-param name="url" select="$source/b:URL"/><xsl:with-param name="options" select="$options"/></xsl:call-template></xsl:when><xsl:when test="starts-with($name, 'Year') and string($source/*[local-name() = $name])"><xsl:call-template name="format-year"><xsl:with-param name="year" select="$source/*[local-name() = $name]"/><xsl:with-param name="options" select="$options"/></xsl:call-template></xsl:when><xsl:when test="starts-with($name, 'Day') and string($source/*[local-name() = $name])"><xsl:call-template name="format-day"><xsl:with-param name="day" select="$source/*[local-name() = $name]"/><xsl:with-param name="options" select="$options"/></xsl:call-template></xsl:when><xsl:when test="contains($name, 'Title') and string($source/*[local-name() = $name])"><xsl:variable name="title"><xsl:call-template name="format-title"><xsl:with-param name="title" select="$source/*[local-name() = $name]"/><xsl:with-param name="options" select="$options"/><xsl:with-param name="delimeter"><xsl:choose><xsl:when test="string-length(msxsl:node-set($data)/overrides/titles/delimeter) > 0"><xsl:value-of select="msxsl:node-set($data)/overrides/titles/delimeter"/></xsl:when><xsl:otherwise><xsl:text>:</xsl:text></xsl:otherwise></xsl:choose></xsl:with-param><xsl:with-param name="articles"><xsl:choose><xsl:when test="string-length(msxsl:node-set($data)/overrides/titles/articles) > 0"><xsl:value-of select="msxsl:node-set($data)/overrides/titles/articles"/></xsl:when><xsl:otherwise><xsl:text>-A-AN-THE-</xsl:text></xsl:otherwise></xsl:choose></xsl:with-param></xsl:call-template></xsl:variable><xsl:choose><xsl:when test="string-length($title) = 0"><xsl:text>%empty%</xsl:text></xsl:when><xsl:otherwise><xsl:value-of select="$title"/></xsl:otherwise></xsl:choose></xsl:when><xsl:when test="$name = 'Edition' and string($source/b:Edition)"><xsl:choose><xsl:when test="contains($options, 'u')"><xsl:call-template name="upper-case"><xsl:with-param name ="string"><xsl:choose><xsl:when test="contains($options, 'o')"><xsl:call-template name="format-ordinal"><xsl:with-param name="number" select="$source/b:Edition"/><xsl:with-param name="options" select="$options"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$source/b:Edition"/></xsl:otherwise></xsl:choose></xsl:with-param></xsl:call-template></xsl:when><xsl:when test="contains($options, 'l')"><xsl:call-template name="lower-case"><xsl:with-param name ="string"><xsl:choose><xsl:when test="contains($options, 'o')"><xsl:call-template name="format-ordinal"><xsl:with-param name="number" select="$source/b:Edition"/><xsl:with-param name="options" select="$options"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$source/b:Edition"/></xsl:otherwise></xsl:choose></xsl:with-param></xsl:call-template></xsl:when><xsl:otherwise><xsl:choose><xsl:when test="contains($options, 'o')"><xsl:call-template name="format-ordinal"><xsl:with-param name="number" select="$source/b:Edition"/><xsl:with-param name="options" select="$options"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$source/b:Edition"/></xsl:otherwise></xsl:choose></xsl:otherwise></xsl:choose></xsl:when><xsl:when test="($name = 'Volume' or $name = 'CitationVolume') and string($source/*[local-name() = $name]) and number($source/*[local-name() = $name]) > 0"><xsl:call-template name="format-number"><xsl:with-param name="number" select="$source/*[local-name() = $name]"/><xsl:with-param name="options" select="translate($options, translate($options, 'R', ''), '')"/></xsl:call-template></xsl:when><xsl:when test="starts-with($name, 'Month') and string($source/*[local-name() = $name])"><xsl:call-template name="format-month"><xsl:with-param name="month" select="$source/*[local-name() = $name]"/><xsl:with-param name="options" select="$options"/></xsl:call-template></xsl:when><xsl:when test="$name = 'SourceType' and string($source/b:SourceType)"><xsl:call-template name="format-sourcetype"><xsl:with-param name="type" select="$source/b:SourceType"/><xsl:with-param name="options" select="$options"/></xsl:call-template></xsl:when><xsl:when test="string($source/*[local-name() = $name])"><xsl:choose><xsl:when test="contains($options, 'u')"><xsl:call-template name="upper-case"><xsl:with-param name ="string" select="$source/*[local-name() = $name]"/></xsl:call-template></xsl:when><xsl:when test="contains($options, 'l')"><xsl:call-template name="lower-case"><xsl:with-param name ="string" select="$source/*[local-name() = $name]"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$source/*[local-name() = $name]"/></xsl:otherwise></xsl:choose></xsl:when></xsl:choose></xsl:if><xsl:if test="string-length($name) = 0"><xsl:text>%empty%</xsl:text></xsl:if></xsl:variable><xsl:if test="$result != '%empty%'"><xsl:call-template name="format-source-part-3"><xsl:with-param name="source" select="$source"/><xsl:with-param name="format" select="substring-after(substring-after($format, $delim), $delim)"/><xsl:with-param name="level" select="$level"/><xsl:with-param name="used" select="$used"/><xsl:with-param name="outputAtCurrentLevel"><xsl:value-of select="$outputAtCurrentLevel"/><xsl:value-of select="substring-before($format, $delim)"/><xsl:value-of select="$result"/></xsl:with-param><xsl:with-param name="usedAtCurrentLevel"><xsl:value-of select="$usedAtCurrentLevel"/><xsl:if test="string-length($name) > 0"><xsl:variable name="options"><xsl:call-template name="substring-before-ex"><xsl:with-param name="string" select="substring-after(substring-before(substring-after($format, $delim), $delim), concat($name, ':'))"/><xsl:with-param name="delimeter" select="'|'"/></xsl:call-template></xsl:variable><xsl:if test="not(contains($options, 'r'))"><xsl:text>-</xsl:text><xsl:value-of select="$name"/><xsl:text>-</xsl:text></xsl:if></xsl:if></xsl:with-param></xsl:call-template></xsl:if></xsl:when><xsl:otherwise><xsl:call-template name="format-source-part-3"><xsl:with-param name="format" select="''"/><xsl:with-param name="outputAtCurrentLevel" select="concat($outputAtCurrentLevel, $format)"/><xsl:with-param name="usedAtCurrentLevel" select="$usedAtCurrentLevel"/></xsl:call-template></xsl:otherwise></xsl:choose></xsl:when><xsl:otherwise><xsl:choose><xsl:when test="not(contains($outputAtCurrentLevel, '%empty%')) and string-length($outputAtCurrentLevel) > 0"><output><xsl:value-of select="$outputAtCurrentLevel"/></output><used><xsl:value-of select="$usedAtCurrentLevel"/></used></xsl:when><xsl:otherwise><output></output><used></used></xsl:otherwise></xsl:choose></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="get-source-parameter"><xsl:param name="parameters"/><xsl:param name="source"/><xsl:param name="used"/><xsl:if test="string-length($parameters) > 0"><xsl:variable name="name"><xsl:call-template name="substring-before-ex"><xsl:with-param name="string"><xsl:call-template name="substring-before-ex"><xsl:with-param name="string" select="$parameters"/><xsl:with-param name="delimeter" select="'|'"/></xsl:call-template></xsl:with-param><xsl:with-param name="delimeter" select="':'"/></xsl:call-template></xsl:variable><xsl:choose><xsl:when test="starts-with($name, '&#x22;') and substring($name, string-length($name), 1) = '&#x22;' and not(contains($used, concat('-', $name)))"><xsl:value-of select="$name"/></xsl:when><xsl:when test="(($name != 'Author' and string($source/*[local-name() = $name])) or string($source/b:Author/*[local-name() = $name])) and not(contains($used, concat('-', $name)))"><xsl:value-of select="$name"/></xsl:when><xsl:otherwise><xsl:call-template name="get-source-parameter"><xsl:with-param name="parameters" select="substring-after($parameters, '|')"/><xsl:with-param name="source" select="$source"/><xsl:with-param name="used" select="$used"/></xsl:call-template></xsl:otherwise></xsl:choose></xsl:if></xsl:template><xsl:template name="format-person"><xsl:param name="person"/><xsl:param name="format"/><xsl:call-template name="format-person-part-2"><xsl:with-param name="person" select="$person"/><xsl:with-param name="format"><xsl:call-template name="preprocess-format-string"><xsl:with-param name="string" select="$format"/></xsl:call-template></xsl:with-param></xsl:call-template></xsl:template><xsl:template name="format-person-part-2"><xsl:param name="person"/><xsl:param name="format"/><xsl:param name="used"/><xsl:choose><xsl:when test="contains($format, '{')"><xsl:variable name="level" select="substring-before(substring-after($format, '{'), '}')"/><xsl:variable name="delim" select="concat('{', $level,'}')"/><xsl:variable name="current"><xsl:call-template name="format-person-part-3"><xsl:with-param name="person" select="$person"/><xsl:with-param name="format" select="substring-before(substring-after($format, $delim), $delim)"/><xsl:with-param name="used" select="$used"/><xsl:with-param name="level" select="$level"/></xsl:call-template></xsl:variable><xsl:value-of select="substring-before($format, $delim)"/><xsl:call-template name="format-person-part-2"><xsl:with-param name="person" select="$person"/><xsl:with-param name="format"><xsl:value-of select="msxsl:node-set($current)/output"/><xsl:value-of select="substring-after(substring-after($format, $delim), $delim)"/></xsl:with-param><xsl:with-param name="used" select="concat($used, msxsl:node-set($current)/used)"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$format"/></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="format-person-part-3"><xsl:param name="person"/><xsl:param name="format"/><xsl:param name="used"/><xsl:param name="level"/><xsl:param name="outputAtCurrentLevel" select="''"/><xsl:param name="usedAtCurrentLevel" select="''"/><xsl:choose><xsl:when test="string-length($format) > 0"><xsl:variable name="delim" select="concat('%', $level, '%')"/><xsl:choose><xsl:when test="contains($format, $delim)"><xsl:variable name="name"><xsl:call-template name="get-person-parameter"><xsl:with-param name="parameters" select="substring-before(substring-after($format, $delim), $delim)"/><xsl:with-param name="person" select="$person"/><xsl:with-param name="used" select="concat($used, $usedAtCurrentLevel)"/></xsl:call-template></xsl:variable><xsl:variable name="result"><xsl:if test="string-length($name) > 0"><xsl:variable name="options"><xsl:call-template name="substring-before-ex"><xsl:with-param name="string" select="substring-after(substring-before(substring-after($format, $delim), $delim), concat($name, ':'))"/><xsl:with-param name="delimeter" select="'|'"/></xsl:call-template></xsl:variable><xsl:variable name="case"><xsl:choose><xsl:when test="contains($options, 'u')"><xsl:call-template name="upper-case"><xsl:with-param name="string" select="$person/*[local-name() = $name]"/></xsl:call-template></xsl:when><xsl:when test="contains($options, 'l')"><xsl:call-template name="lower-case"><xsl:with-param name="string" select="$person/*[local-name() = $name]"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$person/*[local-name() = $name]"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:choose><xsl:when test="contains($options, 'a')"><xsl:call-template name="abbreviate-name"><xsl:with-param name="name" select="$case"/><xsl:with-param name="keepDashes"><xsl:choose><xsl:when test="contains($options, 'd')"><xsl:text>1</xsl:text></xsl:when><xsl:otherwise><xsl:text>0</xsl:text></xsl:otherwise></xsl:choose></xsl:with-param><xsl:with-param name="withPeriods"><xsl:choose><xsl:when test="contains($options, 'p')"><xsl:text>1</xsl:text></xsl:when><xsl:otherwise><xsl:text>0</xsl:text></xsl:otherwise></xsl:choose></xsl:with-param><xsl:with-param name="keepSpaces"><xsl:choose><xsl:when test="contains($options, 's')"><xsl:text>1</xsl:text></xsl:when><xsl:otherwise><xsl:text>0</xsl:text></xsl:otherwise></xsl:choose></xsl:with-param></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$case"/></xsl:otherwise></xsl:choose></xsl:if><xsl:if test="string-length($name) = 0"><xsl:text>%empty%</xsl:text></xsl:if></xsl:variable><xsl:if test="$result != '%empty%'"><xsl:call-template name="format-person-part-3"><xsl:with-param name="person" select="$person"/><xsl:with-param name="format" select="substring-after(substring-after($format, $delim), $delim)"/><xsl:with-param name="level" select="$level"/><xsl:with-param name="used" select="$used"/><xsl:with-param name="outputAtCurrentLevel"><xsl:value-of select="$outputAtCurrentLevel"/><xsl:value-of select="substring-before($format, $delim)"/><xsl:value-of select="$result"/></xsl:with-param><xsl:with-param name="usedAtCurrentLevel"><xsl:value-of select="$usedAtCurrentLevel"/><xsl:if test="string-length($name) > 0"><xsl:variable name="options"><xsl:call-template name="substring-before-ex"><xsl:with-param name="string" select="substring-after(substring-before(substring-after($format, $delim), $delim), concat($name, ':'))"/><xsl:with-param name="delimeter" select="'|'"/></xsl:call-template></xsl:variable><xsl:if test="not(contains($options, 'r'))"><xsl:text>-</xsl:text><xsl:value-of select="$name"/><xsl:text>-</xsl:text></xsl:if></xsl:if></xsl:with-param></xsl:call-template></xsl:if></xsl:when><xsl:otherwise><xsl:call-template name="format-person-part-3"><xsl:with-param name="format" select="''"/><xsl:with-param name="outputAtCurrentLevel" select="concat($outputAtCurrentLevel, $format)"/><xsl:with-param name="usedAtCurrentLevel" select="$usedAtCurrentLevel"/></xsl:call-template></xsl:otherwise></xsl:choose></xsl:when><xsl:otherwise><xsl:choose><xsl:when test="not(contains($outputAtCurrentLevel, '%empty%')) and string-length($outputAtCurrentLevel) > 0"><output><xsl:value-of select="$outputAtCurrentLevel"/></output><used><xsl:value-of select="$usedAtCurrentLevel"/></used></xsl:when><xsl:otherwise><output></output><used></used></xsl:otherwise></xsl:choose></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="get-person-parameter"><xsl:param name="parameters"/><xsl:param name="person"/><xsl:param name="used"/><xsl:if test="string-length($parameters) > 0"><xsl:variable name="name"><xsl:call-template name="substring-before-ex"><xsl:with-param name="string"><xsl:call-template name="substring-before-ex"><xsl:with-param name="string" select="$parameters"/><xsl:with-param name="delimeter" select="'|'"/></xsl:call-template></xsl:with-param><xsl:with-param name="delimeter" select="':'"/></xsl:call-template></xsl:variable><xsl:choose><xsl:when test="string($person/*[local-name() = $name]) and not(contains($used, concat('-', $name)))"><xsl:value-of select="$name"/></xsl:when><xsl:otherwise><xsl:call-template name="get-person-parameter"><xsl:with-param name="parameters" select="substring-after($parameters, '|')"/><xsl:with-param name="person" select="$person"/><xsl:with-param name="used" select="$used"/></xsl:call-template></xsl:otherwise></xsl:choose></xsl:if></xsl:template><xsl:template name="format-corporate"><xsl:param name="corporate"/><xsl:param name="format"/><xsl:variable name="temp"><xsl:variable name="remainder" select="substring-after($format, '%')"/><xsl:value-of select="substring-before($format, '%')"/><xsl:variable name="options"><xsl:call-template name="lower-case"><xsl:with-param name="string" select="substring-after(substring-before($remainder, '%'), ':')"/></xsl:call-template></xsl:variable><xsl:variable name="corp"><xsl:choose><xsl:when test="contains($options, 'a')"><xsl:call-template name="abbreviate-name"><xsl:with-param name="name" select="$corporate"/><xsl:with-param name="keepDashes"><xsl:choose><xsl:when test="contains($options, 'd')"><xsl:text>1</xsl:text></xsl:when><xsl:otherwise><xsl:text>0</xsl:text></xsl:otherwise></xsl:choose></xsl:with-param><xsl:with-param name="withPeriods"><xsl:choose><xsl:when test="contains($options, 'p')"><xsl:text>1</xsl:text></xsl:when><xsl:otherwise><xsl:text>0</xsl:text></xsl:otherwise></xsl:choose></xsl:with-param><xsl:with-param name="keepSpaces"><xsl:choose><xsl:when test="contains($options, 's')"><xsl:text>1</xsl:text></xsl:when><xsl:otherwise><xsl:text>0</xsl:text></xsl:otherwise></xsl:choose></xsl:with-param></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$corporate"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:choose><xsl:when test="contains($options, 'u')"><xsl:call-template name="upper-case"><xsl:with-param name="string" select="$corp"/></xsl:call-template></xsl:when><xsl:when test="contains($options, 'l')"><xsl:call-template name="lower-case"><xsl:with-param name="string" select="$corp"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$corp"/></xsl:otherwise></xsl:choose><xsl:value-of select="substring-after($remainder, '%')"/></xsl:variable><xsl:value-of select="translate($temp, '{}', '')"/></xsl:template><xsl:template name="format-contributors-by-params"><xsl:param name="contributors" /><xsl:param name="params" /><xsl:choose><xsl:when test="string-length($contributors/b:Corporate) > 0"><xsl:value-of select="$params/single_prefix"/><xsl:call-template name="format-corporate"><xsl:with-param name="corporate" select="$contributors/b:Corporate"/><xsl:with-param name="format" select="$params/corporate"/></xsl:call-template><xsl:value-of select="$params/single_suffix"/></xsl:when><xsl:otherwise><xsl:variable name="numPersons" select="count($contributors/b:NameList/b:Person)" /><xsl:if test="$numPersons > 0"><xsl:variable name="numDisplay"><xsl:choose><xsl:when test="$numPersons > $params/max_number_of_persons_to_display"><xsl:value-of select="$params/number_of_persons_to_display_if_more_than_max"/></xsl:when><xsl:otherwise><xsl:value-of select="$numPersons"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:choose><xsl:when test="$numPersons > 1"><xsl:value-of select="$params/multi_prefix"/></xsl:when><xsl:otherwise><xsl:value-of select="$params/single_prefix"/></xsl:otherwise></xsl:choose><xsl:for-each select="$contributors/b:NameList/b:Person"><xsl:variable name="pos" select="position()" /><xsl:choose><xsl:when test="position() > $numDisplay"/><xsl:when test="position() = 1"><xsl:call-template name="format-person"><xsl:with-param name="person" select="." /><xsl:with-param name="format" select="$params/first_person" /></xsl:call-template></xsl:when><xsl:when test="position() = 2 and $numPersons = 2"><xsl:value-of select="$params/separator_between_if_two"/><xsl:call-template name="format-person"><xsl:with-param name="person" select="." /><xsl:with-param name="format" select="$params/other_persons" /></xsl:call-template></xsl:when><xsl:when test="(position() = $numDisplay) and not($numPersons > $numDisplay)"><xsl:value-of select="$params/separator_before_last"/><xsl:call-template name="format-person"><xsl:with-param name="person" select="." /><xsl:with-param name="format" select="$params/other_persons" /></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$params/separator_between_if_more_than_two"/><xsl:call-template name="format-person"><xsl:with-param name="person" select="." /><xsl:with-param name="format" select="$params/other_persons" /></xsl:call-template></xsl:otherwise></xsl:choose></xsl:for-each><xsl:if test="$numPersons > $numDisplay"><xsl:value-of select="$params/overflow"/></xsl:if><xsl:choose><xsl:when test="$numPersons > 1"><xsl:value-of select="$params/multi_suffix"/></xsl:when><xsl:otherwise><xsl:value-of select="$params/single_suffix"/></xsl:otherwise></xsl:choose></xsl:if></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="abbreviate-name"><xsl:param name="name"/><xsl:param name="withPeriods" select="1"/><xsl:param name="keepSpaces" select="1"/><xsl:param name="keepDashes" select="1"/><xsl:choose><xsl:when test="contains($name, '-')"><xsl:call-template name="abbreviate-name"><xsl:with-param name="name" select="substring-before(normalize-space($name), '-')"/><xsl:with-param name="withPeriods" select="$withPeriods"/><xsl:with-param name="keepSpaces" select="$keepSpaces"/><xsl:with-param name="keepDashes" select="$keepDashes"/></xsl:call-template><xsl:if test="$keepDashes = 1"><xsl:text>-</xsl:text></xsl:if><xsl:call-template name="abbreviate-name"><xsl:with-param name="name" select="substring-after(normalize-space($name), '-')"/><xsl:with-param name="withPeriods" select="$withPeriods"/><xsl:with-param name="keepSpaces" select="$keepSpaces"/><xsl:with-param name="keepDashes" select="$keepDashes"/></xsl:call-template></xsl:when><xsl:when test="contains($name, ' ')"><xsl:call-template name="abbreviate-name"><xsl:with-param name="name" select="substring-before(normalize-space($name), ' ')"/><xsl:with-param name="withPeriods" select="$withPeriods"/><xsl:with-param name="keepSpaces" select="$keepSpaces"/><xsl:with-param name="keepDashes" select="$keepDashes"/></xsl:call-template><xsl:if test="$keepSpaces = 1"><xsl:text></xsl:text></xsl:if><xsl:call-template name="abbreviate-name"><xsl:with-param name="name" select="substring-after(normalize-space($name), ' ')"/><xsl:with-param name="withPeriods" select="$withPeriods"/><xsl:with-param name="keepSpaces" select="$keepSpaces"/><xsl:with-param name="keepDashes" select="$keepDashes"/></xsl:call-template></xsl:when><xsl:when test="contains($name, '.') and string-length(substring-after($name, '.')) &gt; 0"><xsl:call-template name="abbreviate-name"><xsl:with-param name="name" select="substring-before(normalize-space($name), '.')"/><xsl:with-param name="withPeriods" select="$withPeriods"/><xsl:with-param name="keepSpaces" select="$keepSpaces"/><xsl:with-param name="keepDashes" select="$keepDashes"/></xsl:call-template><xsl:if test="$keepSpaces = 1"><xsl:text></xsl:text></xsl:if><xsl:call-template name="abbreviate-name"><xsl:with-param name="name" select="substring-after(normalize-space($name), '.')"/><xsl:with-param name="withPeriods" select="$withPeriods"/><xsl:with-param name="keepSpaces" select="$keepSpaces"/><xsl:with-param name="keepDashes" select="$keepDashes"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:if test="string-length($name) > 0"><xsl:value-of select="substring($name,1,1)"/><xsl:if test="$withPeriods = 1"><xsl:text>.</xsl:text></xsl:if></xsl:if></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="abbreviate-to-capitals"><xsl:param name="string"/><xsl:value-of select="translate($string, translate($string, concat($uppercase,'-'), ''), '')"/></xsl:template><xsl:template name="count-contributors"><xsl:param name="contributors" /><xsl:choose><xsl:when test="string-length($contributors/b:Corporate) > 0"><xsl:text>1</xsl:text></xsl:when><xsl:when test="string-length($contributors/b:NameList) > 0"><xsl:value-of select="count($contributors/b:NameList/b:Person)" /></xsl:when><xsl:otherwise><xsl:text>0</xsl:text></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="format-url"><xsl:param name="url"/><xsl:param name="options"/><xsl:if test="string-length($url) > 0"><xsl:if test="contains($options, 'l')"><xsl:text>&lt;a href="</xsl:text><xsl:value-of select="$url"/><xsl:text>"&gt;</xsl:text></xsl:if><xsl:if test="not(contains($options, 'l'))"><xsl:text>&lt;span/&gt;</xsl:text></xsl:if><xsl:choose><xsl:when test="contains($options, 's')"><xsl:call-template name="add-zwsp"><xsl:with-param name="string" select="$url"/><xsl:with-param name="afterChars" select="'/'"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$url"/></xsl:otherwise></xsl:choose><xsl:if test="contains($options, 'l')"><xsl:text>&lt;/a&gt;</xsl:text></xsl:if></xsl:if></xsl:template><xsl:template name="add-zwsp"><xsl:param name="string"/><xsl:param name="afterChars"/><xsl:choose><xsl:when test="string-length($string) > 1"><xsl:value-of select="substring($string, 1, 1)"/><xsl:if test="string-length($afterChars) = 0 or contains($afterChars, substring($string, 1, 1))"><xsl:value-of select="'&#8203;'"/></xsl:if><xsl:call-template name="add-zwsp"><xsl:with-param name="string" select="substring($string, 2)"/><xsl:with-param name="afterChars" select="$afterChars"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$string"/></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="format-year"><xsl:param name="year"/><xsl:param name="options"/><xsl:choose><xsl:when test="contains($options, 's')"><xsl:value-of select="substring($year, 2, 2)"/></xsl:when><xsl:when test="contains($options, 'i')"><xsl:value-of select="9999 - $year"/></xsl:when><xsl:otherwise><xsl:value-of select="$year"/></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="format-sourcetype"><xsl:param name="type"/><xsl:param name="options"/><xsl:variable name="stype"><xsl:choose><xsl:when test="contains($options, 's') and string-length(msxsl:node-set($data)/strings/sourcetypes/sourcetype[@type = $type]) > 0"><xsl:value-of select="msxsl:node-set($data)/strings/sourcetypes/sourcetype[@type = $type]"/></xsl:when><xsl:otherwise><xsl:value-of select="$type"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:choose><xsl:when test="contains($options, 'u')"><xsl:call-template name="upper-case"><xsl:with-param name="string" select="$type"/></xsl:call-template></xsl:when><xsl:when test="contains($options, 'l')"><xsl:call-template name="lower-case"><xsl:with-param name="string" select="$type"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$stype"/></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="format-pages"><xsl:param name="pages"/><xsl:param name="options" select="'p. :pp. '"/><xsl:variable name="singlePagePrefix"><xsl:call-template name="substring-before-ex"><xsl:with-param name="string" select="$options"/><xsl:with-param name="delimeter" select="':'"/></xsl:call-template></xsl:variable><xsl:variable name="multiPagePrefix"><xsl:call-template name="substring-before-ex"><xsl:with-param name="string" select="substring-after($options, ':')"/><xsl:with-param name="delimeter" select="':'"/></xsl:call-template></xsl:variable><xsl:variable name="extraOptions" select="substring-after(substring-after($options, ':'), ':')"/><xsl:variable name="multiPageSeparators"><xsl:value-of select="'&#x002d;&#x003a;&#x2010;&#x2011;&#x2012;&#x2013;&#x8210;&#x8211;'"/></xsl:variable><xsl:variable name="multiPageSeparator"><xsl:value-of select="substring(translate($pages, translate($pages, $multiPageSeparators, ''), ''), 1, 1)"/></xsl:variable><xsl:if test="string-length($pages) > 0"><xsl:choose><xsl:when test="contains($pages, ',') and string-length($multiPageSeparator) = 0"><xsl:value-of select="$multiPagePrefix"/><xsl:value-of select="$pages"/></xsl:when><xsl:when test="string-length($multiPageSeparator) = 0"><xsl:value-of select="$singlePagePrefix"/><xsl:value-of select="$pages"/></xsl:when><xsl:when test="contains($extraOptions, 'a')"><xsl:value-of select="$multiPagePrefix"/><xsl:call-template name="abbreviate-pages"><xsl:with-param name="pages" select="$pages"/><xsl:with-param name="size" select="concat('0', translate($extraOptions, translate($extraOptions, '0123456789', ''), ''))"/><xsl:with-param name="separator" select="$multiPageSeparator"/></xsl:call-template></xsl:when><xsl:when test="contains($extraOptions, 'e')"><xsl:value-of select="$multiPagePrefix"/><xsl:call-template name="extend-pages"><xsl:with-param name="pages" select="$pages"/><xsl:with-param name="separator" select="$multiPageSeparator"/></xsl:call-template></xsl:when><xsl:when test="contains($extraOptions, 'f')"><xsl:value-of select="$multiPagePrefix"/><xsl:call-template name="first-page"><xsl:with-param name="pages" select="$pages"/><xsl:with-param name="separator" select="$multiPageSeparator"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$multiPagePrefix"/><xsl:value-of select="$pages"/></xsl:otherwise></xsl:choose></xsl:if></xsl:template><xsl:template name="abbreviate-pages"><xsl:param name="pages"/><xsl:param name="size" select="'0'"/><xsl:param name="separator"/><xsl:choose><xsl:when test="string-length($separator) > 0"><xsl:call-template name="abbreviate-pages-part-2"><xsl:with-param name="firstPage" select="substring-before($pages, $separator)"/><xsl:with-param name="lastPage" select="substring-after($pages, $separator)"/><xsl:with-param name="separator" select="$separator"/><xsl:with-param name="size" select="$size"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$pages"/></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="abbreviate-pages-part-2"><xsl:param name="firstPage"/><xsl:param name="lastPage"/><xsl:param name="separator" select="'-'"/><xsl:param name="position" select="1"/><xsl:param name="size"/><xsl:choose><xsl:when test="string-length($firstPage) != string-length($lastPage)"><xsl:value-of select="$firstPage"/><xsl:value-of select="$separator"/><xsl:value-of select="$lastPage"/></xsl:when><xsl:when test="substring($firstPage, $position, 1) = substring($lastPage, $position, 1) and string-length(substring($lastPage, $position)) > $size"><xsl:call-template name="abbreviate-pages-part-2"><xsl:with-param name="firstPage" select="$firstPage"/><xsl:with-param name="lastPage" select="$lastPage"/><xsl:with-param name="separator" select="$separator"/><xsl:with-param name="position" select="$position + 1"/><xsl:with-param name="size" select="$size"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$firstPage"/><xsl:value-of select="$separator"/><xsl:value-of select="substring($lastPage, $position)"/></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="extend-pages"><xsl:param name="pages"/><xsl:param name="separator"/><xsl:choose><xsl:when test="string-length($separator) > 0"><xsl:variable name="firstPage" select="substring-before($pages, $separator)"/><xsl:variable name="lastPage" select="substring-after($pages, $separator)"/><xsl:value-of select="$firstPage"/><xsl:value-of select="$separator"/><xsl:if test="string-length($firstPage) > string-length($lastPage)"><xsl:value-of select="substring($firstPage, 1, string-length($firstPage) - string-length($lastPage))"/></xsl:if><xsl:value-of select="$lastPage"/></xsl:when><xsl:otherwise><xsl:value-of select="$pages"/></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="first-page"><xsl:param name="pages"/><xsl:param name="separator"/><xsl:choose><xsl:when test="string-length($separator) > 0"><xsl:value-of select="substring-before($pages, $separator)"/></xsl:when><xsl:when test="contains($pages, ':')"><xsl:value-of select="substring-before($pages, ':')"/></xsl:when><xsl:when test="contains($pages, '-')"><xsl:value-of select="substring-before($pages, '-')"/></xsl:when><xsl:otherwise><xsl:value-of select="$pages"/></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="format-number"><xsl:param name="number"/><xsl:param name="options" select="''"/><xsl:choose><xsl:when test="contains($options, 'r')"><xsl:number value="$number" format="i"/></xsl:when><xsl:when test="contains($options, 'R')"><xsl:number value="$number" format="I"/></xsl:when><xsl:otherwise><xsl:value-of select="$number"/></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="format-ordinal"><xsl:param name="number"/><xsl:param name="options"/><xsl:variable name="digitsOnly"><xsl:value-of select="translate($number, translate($number, '0123456789', ''), '')"/></xsl:variable><xsl:variable name="asNumber"><xsl:choose><xsl:when test="string-length($digitsOnly) > 0"><xsl:value-of select="$digitsOnly"/></xsl:when><xsl:otherwise><xsl:variable name="num"><xsl:call-template name="lower-case"><xsl:with-param name="string" select="$number"/></xsl:call-template></xsl:variable><xsl:choose><xsl:when test="$num = 'first'"><xsl:text>1</xsl:text></xsl:when><xsl:when test="$num = 'second'"><xsl:text>2</xsl:text></xsl:when><xsl:when test="$num = 'third'"><xsl:text>3</xsl:text></xsl:when><xsl:when test="$num = 'fourth'"><xsl:text>4</xsl:text></xsl:when><xsl:when test="$num = 'fifth'"><xsl:text>5</xsl:text></xsl:when><xsl:when test="$num = 'sixth'"><xsl:text>6</xsl:text></xsl:when><xsl:when test="$num = 'seventh'"><xsl:text>7</xsl:text></xsl:when><xsl:when test="$num = 'eighth'"><xsl:text>8</xsl:text></xsl:when><xsl:when test="$num = 'nineth'"><xsl:text>9</xsl:text></xsl:when><xsl:when test="$num = 'tenth'"><xsl:text>10</xsl:text></xsl:when></xsl:choose></xsl:otherwise></xsl:choose></xsl:variable><xsl:choose><xsl:when test="string-length($asNumber) > 0"><xsl:call-template name="format-number"><xsl:with-param name="number" select="$asNumber"/><xsl:with-param name="options" select="translate($options, translate($options, 'R', ''), '')"/></xsl:call-template><xsl:call-template name="format-ordinal-suffix"><xsl:with-param name="number" select="$asNumber"/><xsl:with-param name="options" select="$options"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$number"/></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="format-ordinal-suffix"><xsl:param name="number"/><xsl:param name="options"/><xsl:if test="string-length($number) > 0"><xsl:variable name="suffix"><xsl:choose><xsl:when test="$number mod 100 = 11">th</xsl:when><xsl:when test="$number mod 100 = 12">th</xsl:when><xsl:when test="$number mod 100 = 13">th</xsl:when><xsl:when test="$number mod 10 = 3">rd</xsl:when><xsl:when test="$number mod 10 = 2">nd</xsl:when><xsl:when test="$number mod 10 = 1">st</xsl:when><xsl:otherwise>th</xsl:otherwise></xsl:choose></xsl:variable><xsl:choose><xsl:when test="contains($options, 's')"><xsl:text>&lt;span style='vertical-align: super;'&gt;</xsl:text><xsl:value-of select="$suffix"/><xsl:text>&lt;/span&gt;</xsl:text></xsl:when><xsl:otherwise><xsl:value-of select="$suffix"/></xsl:otherwise></xsl:choose></xsl:if></xsl:template><xsl:template name="format-month"><xsl:param name="month"/><xsl:param name="options"/><xsl:variable name="month2"><xsl:choose><xsl:when test="contains($options, 'i') and string(number($month)) != 'NaN'"><xsl:value-of select="13 - number($month)"/></xsl:when><xsl:otherwise><xsl:value-of select="$month"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:variable name="month3"><xsl:choose><xsl:when test="contains($options, 's') and string(number($month2)) != 'NaN' and string-length(msxsl:node-set($data)/strings/months/month[@number = number($month2)]) > 0"><xsl:value-of select="msxsl:node-set($data)/strings/months/month[@number = number($month2)]"/></xsl:when><xsl:when test="contains($options, 'R') and string(number($month2)) != 'NaN'"><xsl:number value="number($month2)" format="i"/></xsl:when><xsl:when test="contains($options, 'n') and string(number($month2)) != 'NaN'"><xsl:if test="2 > string-length($month2)"><xsl:text>0</xsl:text></xsl:if><xsl:value-of select="$month2"/></xsl:when><xsl:otherwise><xsl:value-of select="$month2"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:choose><xsl:when test="contains($options, 'u')"><xsl:call-template name="upper-case"><xsl:with-param name="string" select="$month3"/></xsl:call-template></xsl:when><xsl:when test="contains($options, 'l')"><xsl:call-template name="lower-case"><xsl:with-param name="string" select="$month3"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$month3"/></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="format-day"><xsl:param name="day"/><xsl:param name="options"/><xsl:variable name="temp0"><xsl:choose><xsl:when test="contains($options, 'i')"><xsl:value-of select="32 - number($day)"/></xsl:when><xsl:otherwise><xsl:value-of select="$day"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:variable name="temp1"><xsl:choose><xsl:when test="contains($options, 'n') and 2 > string-length($temp0) "><xsl:value-of select="concat('0', $temp0)"/></xsl:when><xsl:otherwise><xsl:value-of select="$temp0"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:variable name="temp2"><xsl:choose><xsl:when test="contains($options, 'o')"><xsl:call-template name="format-ordinal"><xsl:with-param name="number" select="$temp1"/><xsl:with-param name="options" select="translate($options, 's', 's')"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$temp1"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:variable name="temp3"><xsl:choose><xsl:when test="contains($options, 'u')"><xsl:call-template name="upper-case"><xsl:with-param name="string" select="$temp2"/></xsl:call-template></xsl:when><xsl:when test="contains($options, 'l')"><xsl:call-template name="lower-case"><xsl:with-param name="string" select="$temp2"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$temp2"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:value-of select="$temp3"/></xsl:template><xsl:template name="format-title"><xsl:param name="title"/><xsl:param name="delimeter" select="':'"/><xsl:param name="articles" select="'-A-AN-THE-'"/><xsl:param name="options"/><xsl:variable name="part"><xsl:choose><xsl:when test="contains($options, 'm')"><xsl:variable name="temp"><xsl:call-template name="substring-before-ex"><xsl:with-param name="string" select="$title"/><xsl:with-param name="delimeter" select="$delimeter"/></xsl:call-template></xsl:variable><xsl:value-of select="normalize-space($temp)"/></xsl:when><xsl:when test="contains($options, 's')"><xsl:value-of select="normalize-space(substring-after($title, $delimeter))"/></xsl:when><xsl:otherwise><xsl:value-of select="$title"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:variable name="sort"><xsl:choose><xsl:when test="contains($options, 'a')"><xsl:variable name="temp1"><xsl:call-template name="substring-before-ex"><xsl:with-param name="string" select="$title"/><xsl:with-param name="delimeter" select="$delimeter"/></xsl:call-template></xsl:variable><xsl:variable name="temp2"><xsl:text>-</xsl:text><xsl:call-template name="upper-case"><xsl:with-param name="string" select="normalize-space($temp1)"/></xsl:call-template><xsl:text>-</xsl:text></xsl:variable><xsl:variable name="firstWords"><xsl:call-template name="upper-case"><xsl:with-param name="string" select="$articles"/></xsl:call-template></xsl:variable><xsl:choose><xsl:when test="contains($firstWords, $temp2)"><xsl:value-of select="substring-after($part, ' ')"/><xsl:text>, </xsl:text><xsl:value-of select="normalize-space($temp1)"/></xsl:when><xsl:otherwise><xsl:value-of select="$part"/></xsl:otherwise></xsl:choose></xsl:when><xsl:otherwise><xsl:value-of select="$part"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:variable name="casing"><xsl:choose><xsl:when test="contains($options, 'u')"><xsl:call-template name="upper-case"><xsl:with-param name="string" select="$sort"/></xsl:call-template></xsl:when><xsl:when test="contains($options, 'l')"><xsl:call-template name="lower-case"><xsl:with-param name="string" select="$sort"/></xsl:call-template></xsl:when><xsl:when test="contains($options, 'f')"><xsl:call-template name="upper-case"><xsl:with-param name="string"><xsl:call-template name="substring-before-ex"><xsl:with-param name="string" select="$sort"/><xsl:with-param name="delimeter" select="' '"/></xsl:call-template></xsl:with-param></xsl:call-template><xsl:text></xsl:text><xsl:value-of select="substring-after($part, ' ')"/></xsl:when><xsl:otherwise><xsl:value-of select="$sort"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:value-of select="$casing"/></xsl:template><xsl:template name="clean-punctuation"><xsl:param name="string"/><xsl:if test="string-length($string) > 0"><xsl:choose><xsl:when test="contains('!?.,;: ', substring($string, 1, 1))"><xsl:call-template name="clean-punctuation"><xsl:with-param name="string" select="substring($string, 2)"/></xsl:call-template></xsl:when><xsl:when test="substring($string, 1, 1) = '&lt;'"><xsl:value-of select="substring-before($string, '&gt;')"/><xsl:value-of select="'&gt;'"/><xsl:call-template name="clean-punctuation"><xsl:with-param name="string" select="substring-after($string, '&gt;')"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:call-template name="clean-punctuation-2"><xsl:with-param name="string" select="$string"/></xsl:call-template></xsl:otherwise></xsl:choose></xsl:if></xsl:template><xsl:template name="clean-punctuation-2"><xsl:param name="string"/><xsl:param name="punctuation" select="''"/><xsl:param name="tagbuffer" select="''"/><xsl:choose><xsl:when test="string-length($string) > 0"><xsl:choose><xsl:when test="contains('!?.,;: ', substring($string, 1, 1))"><xsl:choose><xsl:when test="$punctuation != ''"><xsl:choose><xsl:when test="$punctuation = substring($string, 1, 1)"><xsl:call-template name="clean-punctuation-2"><xsl:with-param name="string" select="substring($string, 2)"/><xsl:with-param name="punctuation" select="$punctuation"/><xsl:with-param name="tagbuffer" select="$tagbuffer"/></xsl:call-template></xsl:when><xsl:when test="contains(' ,;:.', $punctuation) and substring($string, 1, 1) = '.'"><xsl:value-of select="$tagbuffer"/><xsl:call-template name="clean-punctuation-2"><xsl:with-param name="string" select="substring($string, 2)"/><xsl:with-param name="punctuation" select="'.'"/></xsl:call-template></xsl:when><xsl:when test="contains('!?', $punctuation) and contains('!?.', substring($string, 1, 1))"><xsl:value-of select="$punctuation"/><xsl:value-of select="$tagbuffer"/><xsl:call-template name="clean-punctuation-2"><xsl:with-param name="string" select="substring($string, 2)"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$punctuation"/><xsl:value-of select="$tagbuffer"/><xsl:call-template name="clean-punctuation-2"><xsl:with-param name="string" select="substring($string, 2)"/><xsl:with-param name="punctuation" select="substring($string, 1, 1)"/></xsl:call-template></xsl:otherwise></xsl:choose></xsl:when><xsl:otherwise><xsl:value-of select="$tagbuffer"/><xsl:call-template name="clean-punctuation-2"><xsl:with-param name="string" select="substring($string, 2)"/><xsl:with-param name="punctuation" select="substring($string, 1, 1)"/></xsl:call-template></xsl:otherwise></xsl:choose></xsl:when><xsl:when test="substring($string, 1, 1) = '&lt;'"><xsl:call-template name="clean-punctuation-2"><xsl:with-param name="string" select="substring-after($string, '&gt;')"/><xsl:with-param name="punctuation" select="$punctuation"/><xsl:with-param name="tagbuffer" select="concat($tagbuffer, substring-before($string, '&gt;'), '&gt;')"/></xsl:call-template></xsl:when><xsl:when test="substring($string, 1, 1) = '&quot;'"><xsl:call-template name="clean-punctuation-2"><xsl:with-param name="string" select="substring($string, 2)"/><xsl:with-param name="punctuation" select="$punctuation"/><xsl:with-param name="tagbuffer" select="concat($tagbuffer, '&quot;')"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$punctuation"/><xsl:value-of select="$tagbuffer"/><xsl:value-of select="substring($string, 1, 1)"/><xsl:call-template name="clean-punctuation-2"><xsl:with-param name="string" select="substring($string, 2)"/></xsl:call-template></xsl:otherwise></xsl:choose></xsl:when><xsl:otherwise><xsl:value-of select="$punctuation"/><xsl:value-of select="$tagbuffer"/></xsl:otherwise></xsl:choose></xsl:template><xsl:variable name="lowercase" select="'abcdefghijklmnopqrstuvwxyz&#224;&#225;&#226;&#227;&#228;&#229;&#230;&#231;&#232;&#233;&#234;&#235;&#236;&#237;&#238;&#239;&#241;&#242;&#243;&#244;&#245;&#246;&#249;&#250;&#251;&#252;'"/><xsl:variable name="uppercase" select="'ABCDEFGHIJKLMNOPQRSTUVWXYZ&#192;&#193;&#194;&#195;&#196;&#197;&#198;&#199;&#200;&#201;&#202;&#203;&#204;&#205;&#206;&#207;&#209;&#210;&#211;&#212;&#213;&#214;&#217;&#218;&#219;&#220;'"/><xsl:variable name="punctuation" select="'&#9;&#13;&#160;&#32;.,:;!?&#34;&#8216;&#8217;&#8218;&#8220;&#8221;&#8222;&#171;&#187;()[]&lt;&gt;{}'"/><xsl:template name="upper-case"><xsl:param name="string"/><xsl:value-of select="translate($string, $lowercase, $uppercase)"/></xsl:template><xsl:template name="lower-case"><xsl:param name="string"/><xsl:value-of select="translate($string, $uppercase, $lowercase)"/></xsl:template><xsl:template name="substring-before-ex"><xsl:param name="string"/><xsl:param name="delimeter"/><xsl:choose><xsl:when test="contains($string, $delimeter)"><xsl:value-of select="substring-before($string, $delimeter)"/></xsl:when><xsl:otherwise><xsl:value-of select="$string"/></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="substring-after-last"><xsl:param name="string"/><xsl:param name="symbol"/><xsl:choose><xsl:when test="contains($string, $symbol)"><xsl:call-template name="substring-after-last"><xsl:with-param name="string" select="substring-after($string, $symbol)"/><xsl:with-param name="symbol" select="$symbol"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="$string"/></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="substring-before-last"><xsl:param name="string"/><xsl:param name="symbol"/><xsl:if test="contains($string, $symbol)"><xsl:copy-of select="substring-before($string, $symbol)"/><xsl:variable name="temp" select="substring-after($string, $symbol)"/><xsl:if test="contains($temp, $symbol)"><xsl:copy-of select="$symbol"/><xsl:call-template name="substring-before-last"><xsl:with-param name="string" select="$temp"/><xsl:with-param name="symbol" select="$symbol"/></xsl:call-template></xsl:if></xsl:if></xsl:template><xsl:template name="bibword-extensions"><xsl:variable name="extended"><b:BibWord><xsl:for-each select="/b:BibWord/b:Source"><b:Source><xsl:for-each select="./*"><xsl:if test="local-name() != 'BibOrder' and local-name() != 'YearSuffix'"><xsl:copy-of select="."/></xsl:if></xsl:for-each><xsl:variable name="t1" select="./b:Type"/><xsl:variable name="t2" select="./b:SourceType"/><xsl:call-template name="create-sortkey"><xsl:with-param name="source" select="."/></xsl:call-template><b:YSReq><xsl:variable name="key"><xsl:choose><xsl:when test="string-length(msxsl:node-set($data)/extensions/source[@type = $t1]/yearsuffix) > 0"><xsl:call-template name="format-source"><xsl:with-param name="format" select="msxsl:node-set($data)/extensions/source[@type = $t1]/yearsuffix"/><xsl:with-param name="source" select="."/></xsl:call-template></xsl:when><xsl:when test="string-length(msxsl:node-set($data)/extensions/source[@type = $t2]/yearsuffix) > 0"><xsl:call-template name="format-source"><xsl:with-param name="format" select="msxsl:node-set($data)/extensions/source[@type = $t2]/yearsuffix"/><xsl:with-param name="source" select="."/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="substring(concat('00000', ./b:RefOrder), string-length(./b:RefOrder) + 1, 5)"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:call-template name="upper-case"><xsl:with-param name ="string"><xsl:value-of select="$key" disable-output-escaping="yes"/></xsl:with-param></xsl:call-template></b:YSReq></b:Source></xsl:for-each></b:BibWord></xsl:variable><xsl:variable name="sortedForBibOrder"><b:BibWord xmlns:b="http://schemas.openxmlformats.org/officeDocument/2006/bibliography"><xsl:for-each select="msxsl:node-set($extended)/b:BibWord/b:Source"><xsl:sort select="b:SortKey" data-type="text"/><b:Source><xsl:for-each select="./*"><xsl:copy-of select="."/></xsl:for-each></b:Source></xsl:for-each></b:BibWord></xsl:variable><xsl:variable name="withBibOrder"><b:BibWord xmlns:b="http://schemas.openxmlformats.org/officeDocument/2006/bibliography"><xsl:for-each select="msxsl:node-set($sortedForBibOrder)/b:BibWord/b:Source"><b:Source><xsl:for-each select="./*"><xsl:copy-of select="."/></xsl:for-each><b:BibOrder><xsl:value-of select="position()"/></b:BibOrder></b:Source></xsl:for-each></b:BibWord></xsl:variable><xsl:variable name="sortedForYearSuffix"><b:BibWord xmlns:b="http://schemas.openxmlformats.org/officeDocument/2006/bibliography"><xsl:for-each select="msxsl:node-set($withBibOrder)/b:BibWord/b:Source"><xsl:sort select="b:YSReq" data-type="text"/><xsl:sort select="b:SortKey" data-type="text"/><b:Source><xsl:for-each select="./*"><xsl:copy-of select="."/></xsl:for-each></b:Source></xsl:for-each></b:BibWord></xsl:variable><b:BibWord xmlns:b="http://schemas.openxmlformats.org/officeDocument/2006/bibliography"><xsl:for-each select="msxsl:node-set($sortedForYearSuffix)/b:BibWord/b:Source"><b:Source><xsl:for-each select="./*"><xsl:if test="local-name() != 'YSReq' and local-name() != 'SortKey'"><xsl:copy-of select="."/></xsl:if></xsl:for-each><b:YearSuffix><xsl:variable name="current" select="./b:YSReq"/><xsl:variable name="previous" select="preceding-sibling::b:Source[1]/b:YSReq"/><xsl:variable name="next" select="following-sibling::b:Source[1]/b:YSReq"/><xsl:choose><xsl:when test="position() > 1 and $current = $previous"><xsl:call-template name="get-year-suffix"><xsl:with-param name="index" select="position()"/><xsl:with-param name="bibWord" select="$sortedForYearSuffix"/></xsl:call-template></xsl:when><xsl:when test="last() > position() and $current = $next"><xsl:text>a</xsl:text></xsl:when><xsl:otherwise></xsl:otherwise></xsl:choose></b:YearSuffix></b:Source></xsl:for-each></b:BibWord></xsl:template><xsl:template name="get-year-suffix"><xsl:param name="suffixIndex" select="1"/><xsl:param name="index"/><xsl:param name="bibWord"/><xsl:choose><xsl:when test="$index - $suffixIndex > 0 and msxsl:node-set($bibWord)/b:BibWord/b:Source[$index]/b:YSReq = msxsl:node-set($bibWord)/b:BibWord/b:Source[$index - $suffixIndex]/b:YSReq"><xsl:call-template name="get-year-suffix"><xsl:with-param name="suffixIndex" select="$suffixIndex + 1"/><xsl:with-param name="index" select="$index"/><xsl:with-param name="bibWord" select="$bibWord"/></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="substring('abcdefghijklmnopqrstuvwxyz', $suffixIndex, 1)"/></xsl:otherwise></xsl:choose></xsl:template><xsl:template name="create-sortkey"><xsl:param name="source"/><xsl:variable name="formatstring"><xsl:choose><xsl:when test="string-length($source/b:SourceType) = 0 and string-length(msxsl:node-set($data)/bibliography/source[@type = 'Placeholder']/format) > 0"><xsl:value-of select="msxsl:node-set($data)/bibliography/source[@type = 'Placeholder']/sortkey"/></xsl:when><xsl:when test="string-length($source/b:Type) > 0 and string-length(msxsl:node-set($data)/bibliography/source[@type = $source/b:Type]/format) > 0 "><xsl:value-of select="msxsl:node-set($data)/bibliography/source[@type = $source/b:Type]/sortkey"/></xsl:when><xsl:otherwise><xsl:value-of select="msxsl:node-set($data)/bibliography/source[@type = $source/b:SourceType]/sortkey"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:variable name="sortkey"><xsl:call-template name="format-source"><xsl:with-param name="format" select="$formatstring"/><xsl:with-param name="source" select="$source"/></xsl:call-template></xsl:variable><b:SortKey><xsl:choose><xsl:when test="string-length($sortkey) > 0"><xsl:call-template name="upper-case"><xsl:with-param name ="string"><xsl:value-of select="$sortkey" disable-output-escaping="yes"/></xsl:with-param></xsl:call-template></xsl:when><xsl:otherwise><xsl:value-of select="substring(concat('00000', $source/b:RefOrder), string-length($source/b:RefOrder) + 1, 5)"/></xsl:otherwise></xsl:choose></b:SortKey></xsl:template><xsl:variable name="version"><xsl:text>2.9</xsl:text></xsl:variable></xsl:stylesheet>